import { IService } from "../Service";
export interface IPermissionChangeRequest {
    condition: Realm.Sync.PermissionCondition;
    realmPath: string;
    accessLevel: Realm.Sync.AccessLevel;
}
export interface PermissionsServiceConfig {
    enablePermissionRealmReflection?: boolean;
    enableManagementRealmReflection?: boolean;
}
export declare class PermissionsService implements IService {
    private static MANAGEMENT_REALM_REGEX;
    private static ADMIN_REALM_REGEX;
    private readonly enablePermissionRealmReflection;
    private readonly enableManagementRealmReflection;
    private adminRealm;
    private wildcardPermissionRealm;
    private logger;
    private server;
    private handleManagementChangeCallback;
    private handleAdminChangeCallback;
    private pendingHandlerCallbacks;
    private static ensureInTransaction;
    constructor(config?: PermissionsServiceConfig);
    private getManagementRealmForUserId;
    private getUserSpecificPermissionRealm;
    private start;
    private stopping;
    private stop;
    private onDemand;
    private applyPermissions;
    private getOffers;
    private offerPermissions;
    private invalidatePermissionOffer;
    private acceptPermissionOffer;
    private getGrantedPermissions;
    private unreflectPermissionIn;
    private reflectPermissionIn;
    private getUserIdsWithMetadata;
    private grantReadOnlyAccessToWildcardPermissionRealm;
    private grantReadWriteOnUserPermissionRealms;
    private applyPermissionChangeInAdminRealm;
    private handleAdminRealmChange;
    private handleManagementRealmChange;
    private handleGNCallback;
    private handlePermissionOfferObject;
    private handlePermissionOfferResponseObject;
    private handlePermissionChangeObject;
    private validateUserIdCanChangePermissionsForPath;
}
